=== resources/installers/linux/dist/debian/control ===
Package: jubler
Version: @VERSION@
Section: text
Priority: optional
Architecture: @ARCH@
Depends: sun-java5-jre | sun-java6-jre
Recommends: aspell, mplayer
Installed-Size: 900
Maintainer: Panayotis Katsaloulis <panayotis@panayotis.com>
Description: A tool to edit text-based subtitles. It can be used an authoring
 software for new subtitles or as a tool to convert, transform, correct and
 refine existing subtitles.
 .
 The most popular subtitle formats can be used. Preview of the subtitles in
 realtime or in design time, spell checking, translation mode and styles
 editing are some of the main features.
